/* free-list.h */

/* declarations des fonctions de "free-list.c" et definition de qques macros */

#ifndef _free_list_
#define _free_list_


#include "mlvalues.h"

#ifdef ANSI

void make_free_block (address adr, unsigned long len);
void new_free_list (void);
void add_to_free_list (address adr, unsigned long len);
unsigned long get_biggest_free_block_size (void);
void close_free_list (void);
void extract_next_block (void);
void put_back_current_block (void);

#else /* ANSI */

void make_free_block ();
void new_free_list ();
void add_to_free_list ();
unsigned long get_biggest_free_block_size ();
void close_free_list ();
void extract_next_block ();
void put_back_current_block ();

#endif /* ANSI */

#define LINK(blockadr) (* (address *) &H_FIELD ((blockadr), 0))

extern address fl_next;

#define ADD_TO_FREE_LIST(adr, len)  /* longueur TOTALE */		      \
  { Zassert ((len) >= 0);						      \
    if (fl_next == (adr)){						      \
      fl_next += (len);							      \
    }else{								      \
      add_to_free_list ((adr), (len));					      \
    }									      \
  }

extern address hp, block_end;


#endif /* _free_list_ */
