
#include "mlvalues.h"

value compare_strings(s1, s2)   /* ML */
     value s1, s2;
{
  blocksize len1, len2;
  register blocksize len;
  register unsigned char * p1, * p2;

  GET_STRING_LENGTH(s1, len1);
  GET_STRING_LENGTH(s2, len2);
  for (len = (len1 <= len2 ? len1 : len2), p1 = CSTRING(s1), p2 = CSTRING(s2);
       len > 0;
       len--, p1++, p2++)
    if (*p1 != *p2)
      return MLINT(*p1 < *p2 ? -1 : 1);
  if (len1 == len2)
    return MLINT(0);
  else if (len1 < len2)
    return MLINT(-2);
  else
    return MLINT(2);
}

#ifdef ANSI
extern void bcopy(void *, void *, int);
#endif

value blit_string(s1, offset1, s2, offset2, len) /* ML */
     value s1, offset1, s2, offset2, len;
{
  bcopy(&BYTE(s1, CINT(offset1)), &BYTE(s2, CINT(offset2)), CINT(len));
  return atom(0);
}

value blit_vect(v1, offset1, v2, offset2, len) /* ML */
     value v1, offset1, v2, offset2, len;
{
  bcopy(&FIELD(v1, CINT(offset1)),
        &FIELD(v2, CINT(offset2)),
        CINT(len) * sizeof(value));
  return atom(0);
}

value fill_string(s, offset, len, init) /* ML */
     value s, offset, len, init;
{
  register unsigned char * p;
  register blocksize n;
  register unsigned char c;

  c = CINT(init);
  for(p = &BYTE(s, CINT(offset)), n = CINT(len); n > 0; n--, p++) *p = c;
  return s;
}


