#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

void endianness()
{
  long n[2];
  char * p;

  n[0] = 0x41424344;
  n[1] = 0;
  p = (char *) n;
  if (strcmp(p, "ABCD") == 0) {
    printf("Big endian.\n");
  } else if (strcmp(p, "DCBA") == 0) {
    printf("Little endian\n");
  } else {
    printf("Weird architecture -- neither big endian nor little endian.\n");
  }
}

long foo;

void access16(p)
     short * p;
{
  foo = *p;
}

void access32(p)
     long * p;
{
  foo = *p;
}

jmp_buf failure;

void sig_handler()
{
  longjmp(failure, 1);
}

int test(fct, p)
     void (*fct)();
     char * p;
{
  int res;

  signal(SIGSEGV, sig_handler);
  signal(SIGBUS, sig_handler);
  if(setjmp(failure) == 0) {
    fct(p);
    res = 0;
  } else {
    res = 1;
  }
  signal(SIGSEGV, SIG_DFL);
  signal(SIGBUS, SIG_DFL);
  return res;
}

void alignment()
{
  long n[2];
  int align;

#if defined(ultrix) && defined(mips)
  /* Ultrix on DecStations emulates unaligned accesses in software,
     so it appears to this program that there is no alignment constraints.
     This is plain wrong. */
  printf("Alignment constraints (4)\n");
  return;
#endif
  align = 1;
  if (test(access16, (char *) n + 1)) align = 2;
  if (test(access32, (char *) n + 1)) align = 2;
  if (test(access32, (char *) n + 2)) align = 4;
  if (align == 1)
    printf("No alignment constraints\n");
  else
    printf("Alignment constraints (%d)\n", align);
}

main()
{
  endianness();
  alignment();
  exit(0);
}
